//comment out definition to disable

#define ENABLE_PPS_ON_PPS 1
#define ENABLE_PPS_ON_AUX 1
//slot=1..15
#define PPS_TRANSMIT_SLOT 1
//autodetect the most common state and call that idle
#define ENABLE_AUTO_EDGE

//drive VCXO hardware. Do not enable unless you have VCXO.
//#define OCXOTYPE


#ifdef BOARD902
 //this is my first kludge version with overclocked M16
 #define CONFIG_PWR_LED() DDRD|=1<<4
 #define POWER_LED_OFF() PORTD|=(1<<4)
 #define POWER_LED_ON() PORTD&=~(1<<4)
 #define ETHPort _SFR_IO_ADDR(PORTC)
 #define ETHDirection _SFR_IO_ADDR(DDRC)
 #define TxPlusPin 0
 #define TxMinusPin 1
 #define TIFR1 TIFR
 #define TIMSK1 TIMSK
#endif



#ifdef BOARD168
 //this is the release version
 #define CONFIG_PWR_LED()
 #define POWER_LED_OFF()
 #define POWER_LED_ON()
 #define ETHPort _SFR_IO_ADDR(PORTD)
 #define ETHDirection _SFR_IO_ADDR(DDRD)
 #define TxPlusPin 4
 #define TxMinusPin 2

 #define UDR UDR0
 #define TICIE1 ICIE1
#endif
