program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils;


//.set	CRC32init=	0xFFFFFFFF	;
const	CRC32polyInv=	$EDB88320;//	;CRC32 polynom (0x04C11DB7) in inverted bits order
var crc32:longword;

//.set	CRC32	=	CRC32init	;initialisation of CRC32



procedure UDPSendByte(n:byte);
var bit:integer;
begin
  for bit:=0 to 7 do
	if ((n shr bit) and 1)<>0 then begin
    writeln('      out     UDPPort,RegForUDP1');
    writeln('      out     UDPPort,RegForUDP0');
	end else begin
    writeln('      out     UDPPort,RegForUDP0');
    writeln('      out     UDPPort,RegForUDP1');
	end;

  for bit:=0 to 7 do begin
	  if ((CRC32 xor n) and 1)<>0 then
	    CRC32:=(CRC32 shr 1) xor CRC32polyInv
	  else
	    CRC32:=	(CRC32 shr 1);
    n:=n shr 1;
	end;
end;



procedure crconly(n:byte);
var bit:integer;
begin
  for bit:=0 to 7 do begin
	  if ((CRC32 xor n) and 1)<>0 then
	    CRC32:=(CRC32 shr 1) xor CRC32polyInv
	  else
	    CRC32:=	(CRC32 shr 1);
    n:=n shr 1;
	end;
end;



procedure UDPSendByteUDPBit(s0,s1:string);
begin
	writeln('      out     UDPPort,RegForUDP0 		;LSB');
  writeln('      out     UDPPort,RegForUDP1         ');

	writeln('      out     UDPPort,RegForUDP0 		;');
  writeln('      out     UDPPort,RegForUDP1');

	writeln('      out     UDPPort,RegForUDP0 		;');
  writeln('      out     UDPPort,RegForUDP1');

	writeln('      out     UDPPort,RegForUDP0 		;');
  writeln('      out     UDPPort,RegForUDP1');

	writeln('      out     UDPPort,RegForUDP0 		;');
  writeln('      out     UDPPort,RegForUDP1');

	writeln('      out     UDPPort,RegForUDP0 		;');
  writeln('      out     UDPPort,RegForUDP1');

	writeln('      out     UDPPort,RegForUDP0 		;');
  writeln('      out     UDPPort,RegForUDP1');

	writeln('      out     UDPPort,',s1,'			;MSB = UDP bit');
	writeln('      out     UDPPort,',s0,' ');

end;

procedure SendCRCForZero(s0,s1:string);
begin
	writeln(';0');
  writeln('      out     UDPPort,RegForUDP0 	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0 	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1        ');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
	writeln(';4');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
	writeln(';C');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
	writeln(';1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
	writeln(';1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
	writeln(';D');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
	writeln(';B');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
	writeln(';7');
  writeln('      out     UDPPort,RegForUDP0  	;0');
  writeln('      out     UDPPort,RegForUDP1');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
  writeln('      out     UDPPort,',s1,'		;given bit (1 or 0)');
  writeln('      out     UDPPort,',s0,' ');
end;



const MACSourceAddr5 = $00;
const MACSourceAddr4 = $09;
const MACSourceAddr3 = $C1;
const MACSourceAddr2 = $E9;
const MACSourceAddr1 = $53;
const MACSourceAddr0 = $12;


const MACDestAddr5 = $FF;
const MACDestAddr4 = $FF;
const MACDestAddr3 = $FF;
const MACDestAddr2 = $FF;
const MACDestAddr1 = $FF;
const MACDestAddr0 = $FF;

const EthPacketType=$0800;

  IPSourceAddr3=129;
  IPSourceAddr2=129;
  IPSourceAddr1=129;
  IPSourceAddr0=51;

  IPDestAddr3=255;
  IPDestAddr2=255;
  IPDestAddr1=255;
  IPDestAddr0=255;

// UDPDatalength=	44;


procedure infoframe;
var ipchecksum,ccrc32:longword;
  i:integer;
const
 UDPDatalength=	40;
 IPVersionLength=	$45;
 IPTypeOfService=	$00;
 IPLength=		20+8+UDPDataLength;
 IPDatagramID=	$0001;
 IPFlags=		$00;
 IPOffset=		$00;
 IPTimeToLive=	64;
 IPUsedProtocol=	$11;
 UDPSourcePort=	6668;
 UDPDestPort=	{6668} 70;
 UDPMessageLength=	8+UDPDatalength;
 UDPChecksum=	$0000;
begin
  writeln(' ;preamble');
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($D5);

  writeln(' ;dst');
  crc32:=$FFFFFFFF;
  UDPSendByte (MACDestAddr5);
  UDPSendByte (MACDestAddr4);
  UDPSendByte (MACDestAddr3);
  UDPSendByte (MACDestAddr2);
  UDPSendByte (MACDestAddr1);
  UDPSendByte (MACDestAddr0);

  writeln(' ;src');
  UDPSendByte (MACSourceAddr5);
  UDPSendByte (MACSourceAddr4);
  UDPSendByte (MACSourceAddr3);
  UDPSendByte (MACSourceAddr2);
  UDPSendByte (MACSourceAddr1);
  UDPSendByte (MACSourceAddr0);

  writeln(' ;ethertype');
  UDPSendByte (EthPacketType shr 8);
  UDPSendByte (EthPacketType and $FF);
  //readln;

  writeln(' ;ipheader');
 IPchecksum:=	0;
 IPchecksum:=	IPchecksum + (IPVersionLength shl 8) + IPTypeOfService;
 IPchecksum:=	IPchecksum + (IPTypeOfService shl 8) + IPLength;
 IPchecksum:=	IPchecksum + IPDatagramID;
 IPchecksum:=	IPchecksum + (IPFlags         shl 8) + IPOffset;
 IPchecksum:=	IPchecksum + (IPTimeToLive    shl 8) + IPUsedProtocol;
 IPchecksum:=	IPchecksum + (IPSourceAddr3   shl 8) + IPSourceAddr2;
 IPchecksum:=	IPchecksum + (IPSourceAddr1   shl 8) + IPSourceAddr0;
 IPchecksum:=	IPchecksum + (IPDestAddr3     shl 8) + IPDestAddr2;
 IPchecksum:=	IPchecksum + (IPDestAddr1     shl 8) + IPDestAddr0;
 IPchecksum:=	(not (IPchecksum + (IPchecksum shr 16)));

  UDPSendByte (IPVersionLength);
  UDPSendByte (IPTypeOfService);
  UDPSendByte (IPLength shr 8);
  UDPSendByte (IPLength and 255);
  UDPSendByte (IPDatagramID shr 8);
  UDPSendByte (IPDatagramID and 255);
  UDPSendByte (IPFlags);
  UDPSendByte (IPOffset);
  UDPSendByte (IPTimeToLive);
  UDPSendByte (IPUsedProtocol);
  UDPSendByte (IPChecksum shr 8);
  UDPSendByte (IPChecksum and 255);
  UDPSendByte (IPSourceAddr3);
  UDPSendByte (IPSourceAddr2);
  UDPSendByte (IPSourceAddr1);
  UDPSendByte (IPSourceAddr0);
  UDPSendByte (IPDestAddr3);
  UDPSendByte (IPDestAddr2);
  UDPSendByte (IPDestAddr1);
  UDPSendByte (IPDestAddr0);

  writeln(' ;udpheader');
  //udp
  UDPSendByte	(UDPSourcePort shr 8);
  UDPSendByte	(UDPSourcePort and 255);
  UDPSendByte	(UDPDestPort shr 8);
  UDPSendByte	(UDPDestPort and 255);
  UDPSendByte	(UDPMessageLength shr 8);
  UDPSendByte	(UDPMessageLength and 255);
  UDPSendByte	(UDPChecksum shr 8);
  UDPSendByte	(UDPChecksum and 255);
{  crc32:=not crc32;//grundet beregningsmetoden

  writeln(' ;crc fixer');
  ccrc32:=crc32;
  UDPSendByte	((not cCRC32)and 255)	; //skal sendes inverteret
  UDPSendByte	((not cCRC32)shr 8)	;
  UDPSendByte	((not cCRC32)shr 16)	;
  UDPSendByte	((not cCRC32)shr 24)	;

  writeln(' ;data');
  UDPSendByteUDPBit('RegForUDP0bit0', 'RegForUDP1bit0');//	;this sends the bit0 value
  SendCRCForZero	 ('RegForUDP0bit0', 'RegForUDP1bit0');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit1', 'RegForUDP1bit1');//	;this sends the bit1 value
  SendCRCForZero	 ('RegForUDP0bit1', 'RegForUDP1bit1');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit2', 'RegForUDP1bit2');//	;this sends the bit2 value
  SendCRCForZero	 ('RegForUDP0bit2', 'RegForUDP1bit2');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit3', 'RegForUDP1bit3');//	;this sends the bit3 value
  SendCRCForZero	 ('RegForUDP0bit3', 'RegForUDP1bit3');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit4', 'RegForUDP1bit4');//	;this sends the bit4 value
  SendCRCForZero	 ('RegForUDP0bit4', 'RegForUDP1bit4');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit5', 'RegForUDP1bit5');//	;this sends the bit5 value
  SendCRCForZero	 ('RegForUDP0bit5', 'RegForUDP1bit5');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit6', 'RegForUDP1bit6');//	;this sends the bit6 value
  SendCRCForZero	 ('RegForUDP0bit6', 'RegForUDP1bit6');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit7', 'RegForUDP1bit7');//	;this sends the bit7 value
  SendCRCForZero	 ('RegForUDP0bit7', 'RegForUDP1bit7');//	;zero current CRC

  writeln(' ;sum ');
  UDPSendByte ($FF);
  UDPSendByte ($FF);
  UDPSendByte ($FF);
  UDPSendByte ($FF);
 }

  for i:=1 to 5*8 do crconly(0);
  crc32:=not crc32;//grundet beregningsmetoden
  ccrc32:=crc32;

  writeln(' ;data');
  UDPSendByteUDPBit('RegForUDP0bit0', 'RegForUDP1bit0');//	;this sends the bit0 value
  SendCRCForZero	 ('RegForUDP0bit0', 'RegForUDP1bit0');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit1', 'RegForUDP1bit1');//	;this sends the bit1 value
  SendCRCForZero	 ('RegForUDP0bit1', 'RegForUDP1bit1');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit2', 'RegForUDP1bit2');//	;this sends the bit2 value
  SendCRCForZero	 ('RegForUDP0bit2', 'RegForUDP1bit2');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit3', 'RegForUDP1bit3');//	;this sends the bit3 value
  SendCRCForZero	 ('RegForUDP0bit3', 'RegForUDP1bit3');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit4', 'RegForUDP1bit4');//	;this sends the bit4 value
  SendCRCForZero	 ('RegForUDP0bit4', 'RegForUDP1bit4');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit5', 'RegForUDP1bit5');//	;this sends the bit5 value
  SendCRCForZero	 ('RegForUDP0bit5', 'RegForUDP1bit5');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit6', 'RegForUDP1bit6');//	;this sends the bit6 value
  SendCRCForZero	 ('RegForUDP0bit6', 'RegForUDP1bit6');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit7', 'RegForUDP1bit7');//	;this sends the bit7 value
  SendCRCForZero	 ('RegForUDP0bit7', 'RegForUDP1bit7');//	;zero current CRC

  writeln(' ;crc fixer');
  ccrc32:=not ccrc32;
  UDPSendByte	((not cCRC32)and 255)	; //skal sendes inverteret
  UDPSendByte	((not cCRC32)shr 8)	;
  UDPSendByte	((not cCRC32)shr 16)	;
  UDPSendByte	((not cCRC32)shr 24)	;

{  writeln(' ;sum ');
  UDPSendByte ($FF);
  UDPSendByte ($FF);
  UDPSendByte ($FF);
  UDPSendByte ($FF);}
end;







procedure ppsframe;
var ipchecksum,ccrc32:longword;
  i:integer;
const
 UDPDatalength=	40;
 IPVersionLength=	$45;
 IPTypeOfService=	$00;
 IPLength=		20+8+UDPDataLength;
 IPDatagramID=	$0002;
 IPFlags=		$00;
 IPOffset=		$00;
 IPTimeToLive=	64;
 IPUsedProtocol=	$11;
 UDPSourcePort=	6668;
 UDPDestPort=	{6668} 71;
 UDPMessageLength=	8+UDPDatalength;
 UDPChecksum=	$0000;
begin
  writeln(' ;preamble');
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($55);
  UDPSendByte ($D5);

  writeln(' ;dst');
  crc32:=$FFFFFFFF;
  UDPSendByte (MACDestAddr5);
  UDPSendByte (MACDestAddr4);
  UDPSendByte (MACDestAddr3);
  UDPSendByte (MACDestAddr2);
  UDPSendByte (MACDestAddr1);
  UDPSendByte (MACDestAddr0);

  writeln(' ;src');
  UDPSendByte (MACSourceAddr5);
  UDPSendByte (MACSourceAddr4);
  UDPSendByte (MACSourceAddr3);
  UDPSendByte (MACSourceAddr2);
  UDPSendByte (MACSourceAddr1);
  UDPSendByte (MACSourceAddr0);

  i:=(7 shl 13) + 1; //high priority
  UDPSendByte ($81); //802.1Q
  UDPSendByte ($00);
  UDPSendByte (i shr 8);
  UDPSendByte (i and 255);

  writeln(' ;ethertype');
  UDPSendByte (EthPacketType shr 8);
  UDPSendByte (EthPacketType and $FF);
  //readln;

  writeln(' ;ipheader');
 IPchecksum:=	0;
 IPchecksum:=	IPchecksum + (IPVersionLength shl 8) + IPTypeOfService;
 IPchecksum:=	IPchecksum + (IPTypeOfService shl 8) + IPLength;
 IPchecksum:=	IPchecksum + IPDatagramID;
 IPchecksum:=	IPchecksum + (IPFlags         shl 8) + IPOffset;
 IPchecksum:=	IPchecksum + (IPTimeToLive    shl 8) + IPUsedProtocol;
 IPchecksum:=	IPchecksum + (IPSourceAddr3   shl 8) + IPSourceAddr2;
 IPchecksum:=	IPchecksum + (IPSourceAddr1   shl 8) + IPSourceAddr0;
 IPchecksum:=	IPchecksum + (IPDestAddr3     shl 8) + IPDestAddr2;
 IPchecksum:=	IPchecksum + (IPDestAddr1     shl 8) + IPDestAddr0;
 IPchecksum:=	(not (IPchecksum + (IPchecksum shr 16)));

  UDPSendByte (IPVersionLength);
  UDPSendByte (IPTypeOfService);
  UDPSendByte (IPLength shr 8);
  UDPSendByte (IPLength and 255);
  UDPSendByte (IPDatagramID shr 8);
  UDPSendByte (IPDatagramID and 255);
  UDPSendByte (IPFlags);
  UDPSendByte (IPOffset);
  UDPSendByte (IPTimeToLive);
  UDPSendByte (IPUsedProtocol);
  UDPSendByte (IPChecksum shr 8);
  UDPSendByte (IPChecksum and 255);
  UDPSendByte (IPSourceAddr3);
  UDPSendByte (IPSourceAddr2);
  UDPSendByte (IPSourceAddr1);
  UDPSendByte (IPSourceAddr0);
  UDPSendByte (IPDestAddr3);
  UDPSendByte (IPDestAddr2);
  UDPSendByte (IPDestAddr1);
  UDPSendByte (IPDestAddr0);

  writeln(' ;udpheader');
  //udp
  UDPSendByte	(UDPSourcePort shr 8);
  UDPSendByte	(UDPSourcePort and 255);
  UDPSendByte	(UDPDestPort shr 8);
  UDPSendByte	(UDPDestPort and 255);
  UDPSendByte	(UDPMessageLength shr 8);
  UDPSendByte	(UDPMessageLength and 255);
  UDPSendByte	(UDPChecksum shr 8);
  UDPSendByte	(UDPChecksum and 255);
  for i:=1 to 5*8 do crconly(0);
  crc32:=not crc32;//grundet beregningsmetoden
  ccrc32:=crc32;
  writeln(' ;data');
  UDPSendByteUDPBit('RegForUDP0bit0', 'RegForUDP1bit0');//	;this sends the bit0 value
  SendCRCForZero	 ('RegForUDP0bit0', 'RegForUDP1bit0');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit1', 'RegForUDP1bit1');//	;this sends the bit1 value
  SendCRCForZero	 ('RegForUDP0bit1', 'RegForUDP1bit1');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit2', 'RegForUDP1bit2');//	;this sends the bit2 value
  SendCRCForZero	 ('RegForUDP0bit2', 'RegForUDP1bit2');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit3', 'RegForUDP1bit3');//	;this sends the bit3 value
  SendCRCForZero	 ('RegForUDP0bit3', 'RegForUDP1bit3');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit4', 'RegForUDP1bit4');//	;this sends the bit4 value
  SendCRCForZero	 ('RegForUDP0bit4', 'RegForUDP1bit4');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit5', 'RegForUDP1bit5');//	;this sends the bit5 value
  SendCRCForZero	 ('RegForUDP0bit5', 'RegForUDP1bit5');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit6', 'RegForUDP1bit6');//	;this sends the bit6 value
  SendCRCForZero	 ('RegForUDP0bit6', 'RegForUDP1bit6');//	;zero current CRC
  UDPSendByteUDPBit('RegForUDP0bit7', 'RegForUDP1bit7');//	;this sends the bit7 value
  SendCRCForZero	 ('RegForUDP0bit7', 'RegForUDP1bit7');//	;zero current CRC
  writeln(' ;crc fixer');
  ccrc32:=not ccrc32;
  UDPSendByte	((not cCRC32)and 255)	; //skal sendes inverteret
  UDPSendByte	((not cCRC32)shr 8)	;
  UDPSendByte	((not cCRC32)shr 16)	;
  UDPSendByte	((not cCRC32)shr 24)	;
end;

procedure sendbytes(s:string);
begin
  while s<>'' do begin UDPSendByte(ord(s[1])); delete(s,1,1); end;
end;






begin
  if paramstr(1)='i' then infoframe;
  if paramstr(1)='p' then ppsframe;
end.
