
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>

#include "eep.h"  

void backtask(void); //in main

void ee_write(unsigned addr, void *data, unsigned bytes)
{
  unsigned char *p=data;
  unsigned char stat,w;
  while (bytes) {
    backtask();
    stat=SREG;
    cli();
    if (ee_ready()) {
      EEAR=addr;
      EECR|=(1<<EERE);
      w=*(p++);
      if (EEDR!=w) {
        EEDR=w;
//#ifdef EEWE
        EECR|=(1<<EEMWE);
        EECR|=(1<<EEWE);
//#else
  //      EECR|=(1<<EEMPE);
   //     EECR|=(1<<EEPE);

//#endif
      }
      --bytes;
      ++addr;
    }
    SREG=stat;
  }
}

void ee_read(void *data, unsigned addr, unsigned bytes)
{
  unsigned char *p=data;
  unsigned char stat;
  while (bytes) {
    stat=SREG;
    cli();
    if (ee_ready()) {
      EEAR=addr;
      EECR|=(1<<EERE);
      *(p++)=EEDR;
      --bytes;
      ++addr;
    }
    SREG=stat;
  }
}


